# CE Capacity Planning Powershell
# v1 - Rick Fish 11-1-2018
# Requires: Install-Module ImportExcel
Start-Transcript -path .\CapacityPlanningUpdate_Log.txt -append -noclobber
Import-Module ImportExcel

# Variables
$vcloudserver = "cloud.ussignalcom.net"
$filename = ".\CapacityPlanningUpdate.xlsx"
$worksheetname = get-date -format yyyy-MM

$PVDC1 = "GRR-01"
$PVDC2 = "GRR-02"
$PVDC3 = "GRR-03"
$PVDC4 = "GRR-04"
$PVDC5 = "GRR-05"
$PVDC6 = "DTW-01"
$PVDC7 = "DTW-02"
$PVDC8 = "DTW-03"
$PVDC9 = "KWD-DR"
$PVDC10 = "KWD-DR-HICAP"
$PVDC11 = "DTW-DR"
$PVDC12 = "DTW-DR-HICAP"

$vcenter1 = "vmw-mgmt-vc01.vdc.local"
$vcenter2 = "vmw-mgmt-vc05.vdc.local"
$vcenter3 = "vmw-mgmt-vc02.vdc.local"
$vcenter4 = "vmw-mgmt-vc06.dtw.vdc.local"
$vcenter5 = "kwd-mgmt-vc.kwd.vdc.local"
$vcenter6 = "kwd-dr-vc01.kwd.vdc.local"
$vcenter7 = "dtw-dr-vc01.dtw.vdc.local"

$cluster1 = "Cloud Resources - GRR01"
$cluster2 = "Cloud Resources - GRR02"
$cluster3 = "Cloud Resources - GRR03"
$cluster4 = "Cloud Resources - GRR04"
$cluster5 = "Cloud Resources - GRR05"
$cluster6 = "Cloud Resources - Intel DTW"
$cluster7 = "Cloud Resources - Intel DTW-02"
$cluster8 = "Cloud Resources - DTW03"
$cluster9 = "KWD-MGMT"
$cluster10 = "KWD-ENG"
$cluster11 = "KWD-DR-01"
$cluster12 = "KWD-DR-HICAP"
$cluster13 = "DTW-DR-01"
$cluster14 = "DTW-DR-HICAP"

# Set up output file
echo "Stat" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 1
echo "Installed CPU (GHz)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 2
echo "VCD Available CPU (GHz)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 3
echo "Reservation Used CPU (GHz)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 4
echo "Consumed CPU 95th % (GHz)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 5
echo "Installed Memory (GB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 6
echo "VCD Available Memory (GB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 7
echo "Reservation Used Memory (GB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 8
echo "Consumed Memory 95th % (GB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 9
echo "Gold Storage Provisioned (TB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 10
echo "Gold Storage Consumed (TB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 11
echo "Silver Storage Provisioned (TB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 12
echo "Silver Storage Consumed (TB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 13
echo "FileStorage Provisioned (TB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 14
echo "FileStorage Consumed (TB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 15
echo "Standard Storage Provisioned (TB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 16
echo "Standard Storage Consumed (TB)" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 17
echo "Host Count" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 18
echo "M3 Blade Count" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 19
echo "M4 Blade Count" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 20
echo "M5 Blade Count" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 21

# Production Columns
echo "GRR01" | export-excel $filename -worksheetname $worksheetname  -startcolumn 2 -startrow 1
echo "GRR02" | export-excel $filename -worksheetname $worksheetname  -startcolumn 3 -startrow 1
echo "GRR03" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 1
echo "GRR04" | export-excel $filename -worksheetname $worksheetname  -startcolumn 5 -startrow 1
echo "GRR05" | export-excel $filename -worksheetname $worksheetname  -startcolumn 6 -startrow 1
echo "DTW01" | export-excel $filename -worksheetname $worksheetname  -startcolumn 7 -startrow 1
echo "DTW02" | export-excel $filename -worksheetname $worksheetname  -startcolumn 8 -startrow 1
echo "DTW03" | export-excel $filename -worksheetname $worksheetname  -startcolumn 9 -startrow 1
echo "MGMT" | export-excel $filename -worksheetname $worksheetname  -startcolumn 10 -startrow 1
echo "ENG" | export-excel $filename -worksheetname $worksheetname  -startcolumn 11 -startrow 1
echo "KWD-DR" | export-excel $filename -worksheetname $worksheetname  -startcolumn 12 -startrow 1
echo "KWD-DR-HICAP" | export-excel $filename -worksheetname $worksheetname  -startcolumn 13 -startrow 1
echo "DTW-DR" | export-excel $filename -worksheetname $worksheetname  -startcolumn 14 -startrow 1
echo "DTW-DR-HICAP" | export-excel $filename -worksheetname $worksheetname  -startcolumn 15 -startrow 1

Write-host -ForegroundColor Green [Collecting vCloud Director Stats] 
connect-ciserver $vcloudserver

$fullstats = get-providervdc -name $PVDC1
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 8

$fullstats = get-providervdc -name $PVDC2
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 8

$fullstats = get-providervdc -name $PVDC3
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 4 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 4 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 4 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 4 -startrow 8

$fullstats = get-providervdc -name $PVDC4
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 8

$fullstats = get-providervdc -name $PVDC5
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 8

$fullstats = get-providervdc -name $PVDC6
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 7 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 7 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 7 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 7 -startrow 8

$fullstats = get-providervdc -name $PVDC7
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 8 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 8 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 8 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 8 -startrow 8

$fullstats = get-providervdc -name $PVDC8
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 9 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 9 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 9 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 9 -startrow 8

$fullstats = get-providervdc -name $PVDC9
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 12 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 12 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 12 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 12 -startrow 8

$fullstats = get-providervdc -name $PVDC10
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 13 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 13 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 13 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 13 -startrow 8

$fullstats = get-providervdc -name $PVDC11
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 14 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 14 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 14 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 14 -startrow 8

$fullstats = get-providervdc -name $PVDC12
echo $fullstats.CpuTotalGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 15 -startrow 3
echo $fullstats.CpuUsedGHz | export-excel $filename -worksheetname $worksheetname -startcolumn 15 -startrow 4
echo $fullstats.MemoryTotalGB | export-excel $filename -worksheetname $worksheetname -startcolumn 15 -startrow 7
echo $fullstats.MemoryUsedGB | export-excel $filename -worksheetname $worksheetname -startcolumn 15 -startrow 8


disconnect-ciserver -confirm:$false

Write-host -ForegroundColor Green [Collecting Stats for $cluster1]
connect-viserver $vcenter1 #vCenter variable may need updating
$cluster = Get-Cluster -Name $cluster1  #Cluster variable may need updating
$column = 2	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2  
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column  -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "GRR01-GOLD-VCD"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "GRR01-SILV-VCD"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
#Enumerate File Storage? 
$filestorage = get-datastorecluster "GRR-01 FILESTORAGE"  #Datastore Cluster may need to be updated
$filestorage.capacitygb / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 14
$filestorageused = $filestorage.capacitygb - $filestorage.freespacegb
$filestorageused / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 15


Write-host -ForegroundColor Green [Collecting Stats for $cluster2]
$cluster = Get-Cluster -Name $cluster2  #Cluster variable may need updating
$column = 3	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2  
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column  -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "GRR 02 - Gold Raid 5"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "GRR 02 - Silver Raid 6"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
#Enumerate File Storage
$filestorage = get-datastorecluster "GRR-02 FILESTORAGE"  #Datastore Cluster may need to be updated
$filestorage.capacitygb / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 14
$filestorageused = $filestorage.capacitygb - $filestorage.freespacegb
$filestorageused / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 15
disconnect-viserver * -confirm:$false


Write-host -ForegroundColor Green [Collecting Stats for $cluster3]
connect-viserver $vcenter2 #vCenter variable may need updating
$cluster = Get-Cluster -Name $cluster3  #Cluster variable may need updating
$column = 4	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "GRR03_GOLD"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "GRR03_SILVER"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
# Enumerate File Storage
$filestorage = get-datastorecluster "GRR03_FILESTORAGE"  #Datastore Cluster may need to be updated
$filestorage.capacitygb / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 14
$filestorageused = $filestorage.capacitygb - $filestorage.freespacegb
$filestorageused / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 15


Write-host -ForegroundColor Green [Collecting Stats for $cluster4]
$cluster = Get-Cluster -Name $cluster4  #Cluster variable may need updating
$column = 5	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "GRR04_GOLD"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "GRR04_SILVER"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
# Enumerate File Storage
$filestorage = get-datastorecluster "GRR04_FILESTORAGE"  #Datastore Cluster may need to be updated
$filestorage.capacitygb / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 14
$filestorageused = $filestorage.capacitygb - $filestorage.freespacegb
$filestorageused / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 15

Write-host -ForegroundColor Green [Collecting Stats for $cluster5]
$cluster = Get-Cluster -Name $cluster5  #Cluster variable may need updating
$column = 6	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "GRR05_GOLD"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "GRR05_SILVER"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
# Enumerate File Storage - Doesnt Exist Yet in 05
#$filestorage = get-datastorecluster "GRR05_FILESTORAGE"  #Datastore Cluster may need to be updated
#$filestorage.capacitygb / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 14
#$filestorageused = $filestorage.capacitygb - $filestorage.freespacegb
#$filestorageused / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 15
disconnect-viserver * -confirm:$false


Write-host -ForegroundColor Green [Collecting Stats for $cluster6]
connect-viserver $vcenter3 #vCenter variable may need updating
$cluster = Get-Cluster -Name $cluster6  #Cluster variable may need updating
$column = 7	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW_GOLD"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW_SILVER"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
# Enumerate File Storage
$filestorage = get-datastorecluster "DTW-01 FILESTORAGE"  #Datastore Cluster may need to be updated
$filestorage.capacitygb / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 14
$filestorageused = $filestorage.capacitygb - $filestorage.freespacegb
$filestorageused / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 15

Write-host -ForegroundColor Green [Collecting Stats for $cluster7]
$cluster = Get-Cluster -Name $cluster7  #Cluster variable may need updating
$column = 8	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW02 GOLD"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW02 SILVER"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
# Enumerate File Storage - Doesnt Exist Yet in 05
$filestorage = get-datastorecluster "DTW-02 FILESTORAGE"  #Datastore Cluster may need to be updated
$filestorage.capacitygb / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 14
$filestorageused = $filestorage.capacitygb - $filestorage.freespacegb
$filestorageused / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 15
disconnect-viserver * -confirm:$false

Write-host -ForegroundColor Green [Collecting Stats for $cluster8]
connect-viserver $vcenter4 #vCenter variable may need updating
$cluster = Get-Cluster -Name $cluster8  #Cluster variable may need updating
$column = 9	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW03_GOLD"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW03_SILVER"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
# Enumerate File Storage - Doesnt Exist Yet
#$filestorage = get-datastorecluster "DTW-01 FILESTORAGE"  #Datastore Cluster may need to be updated
#$filestorage.capacitygb / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 14
#$filestorageused = $filestorage.capacitygb - $filestorage.freespacegb
#$filestorageused / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 15
disconnect-viserver * -confirm:$false

Write-host -ForegroundColor Green [Collecting Stats for $cluster9]
connect-viserver $vcenter5 #vCenter variable may need updating
$cluster = Get-Cluster -Name $cluster9  #Cluster variable may need updating
$column = 10	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-datastorecluster "KWD-MGMT-GOLD" # Datastore Cluster may need to be updated
$gold.capacitygb / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldconsumed = $gold.capacitygb - $gold.freespacegb
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11

Write-host -ForegroundColor Green [Collecting Stats for $cluster10]
$cluster = Get-Cluster -Name $cluster10  #Cluster variable may need updating
$column = 11	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-datastorecluster "ENG-GOLD" # Datastore Cluster may need to be updated
$gold.capacitygb / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldconsumed = $gold.capacitygb - $gold.freespacegb
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
disconnect-viserver * -confirm:$false

Write-host -ForegroundColor Green [Collecting Stats for $cluster11]
connect-viserver $vcenter6 #vCenter variable may need updating
$cluster = Get-Cluster -Name $cluster11  #Cluster variable may need updating
$column = 12	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "KWD_DR_GOLD"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "KWD_DR_SILVER"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
# Enumerate Storage Standard
$standard = get-cluster $cluster | get-vmhost | get-datastore -Tag "KWD_DR_STANDARD"  #Tag name may need to be updated
$standardtotal = $standard.capacitygb | measure-object -sum
$standardtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 16
$standardfree = $standard.freespacegb | measure-object -sum
$standardconsumed = $standardtotal.sum - $standardfree.sum
$standardconsumed /1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 17

Write-host -ForegroundColor Green [Collecting Stats for $cluster12]
$cluster = Get-Cluster -Name $cluster12  #Cluster variable may need updating
$column = 13	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "KWD_DR_HICAP_GOLD"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "KWD_DR_HICAP_SILVER"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
# Enumerate Storage Standard
$standard = get-cluster $cluster | get-vmhost | get-datastore -Tag "KWD_DR_HICAP_STANDARD"  #Tag name may need to be updated
$standardtotal = $standard.capacitygb | measure-object -sum
$standardtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 16
$standardfree = $standard.freespacegb | measure-object -sum
$standardconsumed = $standardtotal.sum - $standardfree.sum
$standardconsumed /1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 17
disconnect-viserver * -confirm:$false

Write-host -ForegroundColor Green [Collecting Stats for $cluster13]
connect-viserver $vcenter7 #vCenter variable may need updating
$cluster = Get-Cluster -Name $cluster13  #Cluster variable may need updating
$column = 14	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
@($M4s).Count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20 # Experienced a .count bug. This line is nonstandard.
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold
$gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW-DR-GOLD"  #Tag name may need to be updated
$goldtotal = $gold.capacitygb | measure-object -sum
$goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
$goldfree = $gold.freespacegb | measure-object -sum
$goldconsumed = $goldtotal.sum - $goldfree.sum
$goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW-DR-SILVER"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
# Enumerate Storage Standard
$standard = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW-DR-STANDARD"  #Tag name may need to be updated
$standardtotal = $standard.capacitygb | measure-object -sum
$standardtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 16
$standardfree = $standard.freespacegb | measure-object -sum
$standardconsumed = $standardtotal.sum - $standardfree.sum
$standardconsumed /1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 17

Write-host -ForegroundColor Green [Collecting Stats for $cluster14]
$cluster = Get-Cluster -Name $cluster14  #Cluster variable may need updating
$column = 15	 #Column may need updating
$cluster_view = Get-View ($cluster)
$resourceSummary=$cluster_view.GetResourceUsage()
$GHz = $resourceSummary.CpuCapacityMHz/1000
echo $GHz | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 2
$GB = $resourceSummary.MemCapacityMB/1024
echo $GB | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 6 
# Get Host Count
$hosts = Get-Cluster $cluster | Get-VMHost 
echo $hosts.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 18 
# Enumerate Model Counts
$M3s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M3"}
echo $M3s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 19
$M4s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M4"}
echo $M4s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 20
$M5s = get-cluster $cluster | get-vmhost | select name,model | where-object {$_.model -like "UCSB-B200-M5"}
echo $M5s.count | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 21
# Enumerate Storage Gold - Doesnt Exist Yet
# $gold = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW-DR-HICAP-GOLD"  #Tag name may need to be updated
# $goldtotal = $gold.capacitygb | measure-object -sum
# $goldtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 10
# $goldfree = $gold.freespacegb | measure-object -sum
# $goldconsumed = $goldtotal.sum - $goldfree.sum
# $goldconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 11
# Enumerate Storage Silver
$silver = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW-DR-HICAP-SILVER"  #Tag name may need to be updated
$silvertotal = $silver.capacitygb | measure-object -sum
$silvertotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 12
$silverfree = $silver.freespacegb | measure-object -sum
$silverconsumed = $silvertotal.sum - $silverfree.sum
$silverconsumed / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 13
# Enumerate Storage Standard - Doesnt Exist Yet
# $standard = get-cluster $cluster | get-vmhost | get-datastore -Tag "DTW-DR-HICAP-STANDARD"  #Tag name may need to be updated
# $standardtotal = $standard.capacitygb | measure-object -sum
# $standardtotal.sum / 1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 16
# $standardfree = $standard.freespacegb | measure-object -sum
# $standardconsumed = $standardtotal.sum - $standardfree.sum
# $standardconsumed /1024 | export-excel $filename -worksheetname $worksheetname -startcolumn $column -startrow 17
disconnect-viserver * -confirm:$false

# Email Results
send-mailmessage -to rfish@ussignal.com -subject CapacityStats -body "Capacity Stats from the past 30 days." -smtpserver 172.16.11.10 -attachments c:\users\rfish\desktop\CapacityPlanningUpdate.xlsx -from CapacityStats@ussignal.com

# Clean Up
Write-host -ForegroundColor Green [Grabbing Stats Complete]
Stop-Transcript