$clusters = (get-cluster | where {($_.Name -ne 'Staging') -and ($_.Name -ne 'Onboarding-76THMI00')}).Name

$clusterobject = @()
foreach ($cluster in $clusters){
$clusterinfo = (Get-Cluster $cluster).ExtensionData.Summary.UsageSummary 
$clustername = (Get-Cluster $cluster).Name
$TotalCPUCapacityMHZ = ($clusterinfo).TotalCPUCapacityMHZ
$CPUReservationMHz = ($clusterinfo).CPUReservationMHz
$TotalMemCapacityMB = ($clusterinfo).TotalMemCapacityMB
$MemreservationMB = ($clusterinfo).MemreservationMB

$clusterObj = new-object psobject -Property @{
clustername = $clustername
TotalCPUCapacityMHZ = $TotalCPUCapacityMHZ
CPUReservationMHz = $CPUReservationMHz
TotalMemCapacityMB = $TotalMemCapacityMB
MemreservationMB = $MemreservationMB
}
$clusterObject += $clusterObj
}
Write-output $clusterobject | Select Clustername,TotalCPUCapacityMHZ,CPUReservationMHz,TotalMemCapacityMB,MemreservationMB | ft