$chart = New-ExcelChart -Title Usage -ChartType BarClustered -Header 'Usage' `
    -XRange 'Usage[Name]' -YRange @('Usage[Mem Usage( % )]','Usage[CPU Usage( % )]')

Get-ResourcePool 'UA66MK vDC GRR_02 (b117e877-93cc-457e-800d-087819ec925a)' | Get-VM | Select Name, @{N="Mem Usage( % )" ; E={ $_ | Get-Stat -Stat mem.usage.average -MaxSamples 1 -Start (Get-Date).AddDays(-1) -IntervalMins 60}} ,@{N="CPU Usage( % )" ;E={ $_ | Get-Stat -Stat cpu.usage.average -MaxSamples 1 -Start (Get-Date).AddDays(-1) -IntervalMins 60}} | Export-Excel -Path C:\Users\tverkade\Desktop\report.xlsx -WorkSheetname Usage -TableName Usage -ExcelChartDefinition $chart -Show