$metrics = "disk.numberwrite.summation","disk.numberread.summation"
$start = (Get-Date).AddMinutes(-5)
$report = @()

$vms = Get-VM | where {$_.PowerState -eq "PoweredOn"}
$stats = Get-Stat -Realtime -Stat $metrics -Entity $vms -Start $start
$interval = $stats[0].IntervalSecs
$storageprov = 0
$storageused = 0

$lunTab = @{}
foreach($ds in (Get-Datastore -VM $vms | where {$_.Type -eq "VMFS"})){
	$ds.ExtensionData.Info.Vmfs.Extent | %{
		$lunTab[$_.DiskName] = $ds.Name
	}
}
#foreach ($vm in (Get-VM | where {$_.PowerState -eq "PoweredOn"})){
#		$storageprov = Get-VM $vm | Select UsedSpaceGB
#		$storageused = Get-VM $vm | Select ProvisionedSpaceGB
#		}
		
$report = $stats | Group-Object -Property {$_.Entity.Name},Instance | %{
	New-Object PSObject -Property @{
		VM = $_.Values[0]
 		Disk = $_.Values[1]
 		IOPSMax = ($_.Group | `
 			Group-Object -Property Timestamp | `
 			%{$_.Group[0].Value + $_.Group[1].Value} | `
 			Measure-Object -Maximum).Maximum / $interval
		Datastore = $lunTab[$_.Values[1]]
		StorageUsed = Get-VM $_.Values[0] | Select UsedSpaceGB
		StorageProv = Get-VM $_.Values[0] | Select ProvisionedSpaceGB
	}
}

$report
