$reportPath = "$HOME\Desktop\upgradable-VSEs.csv"

$report = @()

Write-Host "Searching for all vShield Edges..." -ForegroundColor Yellow

$edges = Get-View -ViewType virtualmachine -Property Name,Config -Filter @{'Config.VAppConfig.Product[0].Name'='vShield Edge'} | % {

$edge = '' | Select 'Name','Version'

$edge.Name = $_.Name

$edge.Version = $_.config.vappconfig.product[0].version

$report += $edge

}

$highestVersion = ($report | Sort version -Descending)[0].version

Write-Host "Highest vShield Edge version: $highestVersion" -ForegroundColor Yellow

Write-Host "Exporting upgradeable vShield Edges..." -ForegroundColor Yellow

$upgradableVSEs = $report | Where {$_.version -lt $highestVersion}

Write-Host "Saving file to: $reportPath" -ForegroundColor Yellow
$upgradableVSEs | Export-Csv -Path $reportPath -NoTypeInformation -UseCulture