#create a fixed size byte array for later use.  make it the required file size.
$bytearray = New-Object byte[] 20480

#create and start a stopwatch object to measure how long it all takes.
$stopwatch = [Diagnostics.Stopwatch]::StartNew()

#create a CSRNG object
$RNGObject = New-Object Security.Cryptography.RNGCryptoServiceProvider

#Create a folder based on the current date
$folderName = $((Get-Date).ToString('yyyy-MM-dd_hh-mm'))
mkdir C:\Test\$folderName

# set up a loop to run 50000 times
0..9999 | Foreach-Object {

    # create a file stream handle with a name format 'filennnnn'
    $stream = New-Object System.IO.FileStream("C:\Test\$folderName\file$("{0:D5}" -f $_)"), Create

    # and a stream writer handle
    $writer = New-Object System.IO.BinaryWriter($stream)

    # Fill our array from the CSRNG
    $RNGObject.GetNonZeroBytes($bytearray)

    # Append to the current file
    $writer.write($bytearray)

    # Close the stream
    $stream.close()

}

# how long did it all take?
$stopwatch.stop()
$stopwatch