#Begin
Import-Module ImportExcel

#Global Variables
	#UCS Domains
		$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
		$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
		$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
		$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
		$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
		$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70
		$ucsdomains = $kwd1,$kwd2,$kwd3,$dtw1,$dtw2,$dtw3
		
	#Credentials
		$c = Get-Credential

	#Misc Names
		$date = get-date -format yyyy-MM-dd

foreach($UCSDOMAIN in $UCSDOMAINS){

#Connect and Collect
Connect-Ucs $UCSDOMAIN -Credential $c
$filename = ".\" + "$Date_" + "$UCSDOMAIN" + "_Blade_Report.csv"
$UCSchassis = (get-ucschassis | select Id).ID

#Function to collect blade report
#$bladeobject = @()
ForEach ($UCSchassisID in $UCSchassis){
	#Set up output file
	$blades = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID)}).Serial
	$
$bladeobject = @()
ForEach ($blade in $blades){
	$bladeinfo = Get-UCSBlade | Where {($_.Serial -eq $blade)}
	$BladeSlotID = ($bladeinfo).SlotID
	$BladeAssignedToDn = ($bladeinfo).AssignedToDn 
	$BladeUsrLbl = ($bladeinfo).UsrLbl 
	$BladeModel = ($bladeinfo).Model 
	$BladeVID = ($bladeinfo).VID 
	$BladeSerial = ($bladeinfo).Serial 
	$BladeAssociation = ($bladeinfo).Association
	$BladeTotalMemory = ($bladeinfo).TotalMemory
	$BladeNumOfCpus = ($bladeinfo).NumOfCpus
	$BladeNumOfCores = ($bladeinfo).NumOfCores
	$BladeMkt = ($bladeinfo).Ucs
	$currentchassis = $UCSChassisID.ID
	
	$bladeObj = new-object psobject -Property @{
	ChassisID = $currentchassis
	BladeSlotID = $BladeSlotID
	BladeAssignedToDn = $BladeAssignedToDn 
	BladeUsrLbl = $BladeUsrLbl
	BladeModel = $BladeModel
	BladeVID = $BladeVID
	BladeSerial = $BladeSerial
	BladeAssociation = $BladeAssociation
	BladeTotalMemory = $BladeTotalMemory
	BladeNumOfCpus = $BladeNumOfCpus
	BladeNumOfCores = $BladeNumOfCores
	BladeMkt = $BladeMkt
	}
$bladeobject += $bladeObj
write-output $bladeobj | Select bladeMkt,ChassisID,BladeSlotID,BladeAssignedToDn,BladeUsrLbl,BladeModel,BladeVID,BladeSerial,BladeAssociation,BladeTotalMemory,BladeNumOfCpus,BladeNumOfCores | export-csv $filename -notypeinformation -append
}
}
Disconnect-Ucs
	#write-output $bladeobject | Select bladeMkt,BladeSlotID,BladeAssignedToDn,BladeUsrLbl,BladeModel,BladeVID,BladeSerial,BladeAssociation,BladeTotalMemory,BladeNumOfCpus,BladeNumOfCores | export-csv $filename -notypeinformation -append
}

