#Begin
Import-Module ImportExcel

#UCS Power Stats
#Get-UcsBlade | Get-UcsComputeBoard | Get-UcsComputeMbPowerStats

#Variables
	#UCS Domains
		$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
		$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
		$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
		$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
		$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
		$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70
		
	#Credentials
		$c = Get-Credential

	#Misc Names
		$date = get-date -format yyyy-MM-dd
		$filename = ".\$ucs_UCS_Report_$date.xlsx"
		$date = get-date -format yyyy-MM-dd
		$ucs = "blank"
		$chassis = "blank"
		$UCSchassis = "blank"

	#Blade Info
	$BladeAssignedToDn = "blank"
	$BladeUsrLbl = "blank"
	$BladeModel = "blank"
	$BladeVid = "blank"
	$BladeSerial = "blank"
	$BladeAssociation = "blank"
	$BladeTotalMemory = "blank"
	$BladeNumOfCpus = "blank"
	$BladeNumOfCores = "blank"
	$BladeSlotID = "blank"


		
#Define UCS domains
$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70

#Connect and Collect
Connect-Ucs $kwd2 -Credential $c
$ucs = (get-ucschassis | Get-UcsBlade | select Ucs | Select-Object -first 1).ucs
$UCSchassis = (get-ucschassis | select Id).ID
#$worksheetname = $UCSchassisID
#get-ucschassis | Get-UcsBlade | select ChassisId,SlotId,AssignedTodn,AssignedToDn,Model,Vid,Serial,Association,TotalMemory,NumOfCpus,NumOfCores,Ucs | Export-CSV UCS_report.csv -append -NoTypeInformation


ForEach ($UCSChassisID in $UCSchassis){
	# Set up output file
	#$worksheetname = $UCSchassisID
	echo "Chassis #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 1
	echo $UCSchassisID | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 1
	#odd slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 2
	echo "Slot 1" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 3
	echo "Slot 3" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 4
	echo "Slot 5" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 5
	echo "Slot 7" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 6
	#even slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $worksheetname  -startcolumn 5 -startrow 2
	echo "Slot 2" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 3
	echo "Slot 4" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 4
	echo "Slot 6" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 5
	echo "Slot 8" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 6
	
	#Grab Slot Information
	$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $chassis) -and ($_.SlotID -eq '1' -or '3' -or '5' -or '7')} ).AssignedToDn 
	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3                                                                                         
	$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $chassis) -and ($_.SlotID -eq '2' -or '4' -or '6' -or '8')} ).AssignedToDn 
	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3
	
	#Grab Blade Information
	$BladeSlotID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).SlotID
	echo $BladeSlotID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 1 -startrow 9
	
	$BladeAssignedToDn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).AssignedToDn 
	echo $BladeAssignedToDn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 9
	
	$BladeUsrLbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).UsrLbl 
	echo $BladeUsrLbl | export-excel $filename -worksheetname $UCSchassisID -startcolumn 3 -startrow 9

	$BladeModel = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Model 
	echo $BladeModel | export-excel $filename -worksheetname $UCSchassisID -startcolumn 4 -startrow 9	
	
	$BladeVID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).VID 
	echo $BladeVID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 9	
	
	$BladeSerial = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Serial 
	echo $BladeSerial | export-excel $filename -worksheetname $UCSchassisID -startcolumn 6 -startrow 9
	
	$BladeAssociation = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Association
	echo $BladeAssociation | export-excel $filename -worksheetname $UCSchassisID -startcolumn 7 -startrow 9
	
	$BladeTotalMemory = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).TotalMemory
	echo $BladeTotalMemory | export-excel $filename -worksheetname $UCSchassisID -startcolumn 8 -startrow 9
	
	$BladeNumOfCpus = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCpus
	echo $BladeNumOfCpus | export-excel $filename -worksheetname $UCSchassisID -startcolumn 9 -startrow 9
	
	$BladeNumOfCores = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCores
	echo $BladeNumOfCores | export-excel $filename -worksheetname $UCSchassisID -startcolumn 10 -startrow 9
	
}

Disconnect-Ucs