#Define vCenters
$dtwdr = 'dtw-dr-vc01.dtw.vdc.local'
$dtwmgmt = 'dtw-mgmt-vc.dtw.vdc.local'
$kwddr = 'kwd-dr-vc01.kwd.vdc.local'
$kwdmgmt = 'kwd-mgmt-vc.kwd.vdc.local'
$vc01 = 'vmw-mgmt-vc01.grr.vdc.local'
$vc02 = 'vmw-mgmt-vc02.vdc.local'
$vc05 = 'vmw-mgmt-vc05.grr.vdc.local'
$vc06 = 'vmw-mgmt-vc06.dtw.vdc.local'
$vCenters = $vc01,$vc02,$vc05,$vc06#,$dtwdr,$dtwmgmt,$kwddr,$kwdmgmt

foreach($vCenter in $vCenters){
#Connect to the Desired vCenter
$filename = "$vCenter" + "_CBAS_Usage.csv"
$connection = connect-viserver $vCenter
#$Clusters = (Get-Cluster | Where {($_.Name -ne "Staging")}).Name
$Clusters = (Get-Cluster | Where {($_.Name -ne "Staging") -and ($_.Name -ne "Cloud Resources - GRR02") -and ($_.Name -ne "Onboarding-76THMI00")}).Name
foreach($Cluster in $Clusters){
$filename = "$Cluster" + "_CBAS_Usage.csv"
$CBASData = (Get-Cluster $cluster | Get-ResourcePool "USS CBAS" | Get-VM | Where {$_.PowerState -eq "PoweredOn"} | Select @{N="Network Usage (Average), KBps" ; E={[Math]::Round((($_ | Get-Stat -Stat net.usage.average -Start (Get-Date).AddDays(-7) -IntervalMins 5 | Measure-Object Value -Average).Average),2)}}) #| Export-CSV -notypeinformation $filename -append
$CBASDataMax = (Get-Cluster $cluster | Get-ResourcePool "USS CBAS" | Get-VM | Where {$_.PowerState -eq "PoweredOn"} | Select @{N="Network Usage (Maximum), KBps" ; E={[Math]::Round((($_ | Get-Stat -Stat net.usage.average -Start (Get-Date).AddDays(-7) -IntervalMins 5 | Measure-Object Value -Maximum).Maximum),2)}}) 
$Cluster
($CBASData | Measure-Object "Network Usage (Average), KBps" -Sum).Sum
($CBASDataMax | Measure-Object "Network Usage (Maximum), KBps" -Sum).Sum
}
Disconnect-VIServer -Server * -Force -Confirm:$false
}



