
#Get Cluster CPU Stats
#$ClusterCPU = Get-Cluster -PipelineVariable cluster | Select @{N='Cluster';E={$cluster.Name}},@{N='CPUCapacity';E={$_.ExtensionData.Summary.UsageSummary.TotalCpuCapacityMhz}},@{N='CPUReservation';E={$_.ExtensionData.Summary.UsageSummary.CpuReservationMhz}},@{N='CPUDemand';E={$_.ExtensionData.Summary.UsageSummary.CpuDemandMhz}},@{N='CPUEntitled';E={$_.ExtensionData.Summary.UsageSummary.CpuEntitledMhz}} | FT


#$ClusterMem = Get-Cluster -PipelineVariable cluster | Select @{N='Cluster';E={$cluster.Name}},@{N='MemCapacityMB';E={$_.ExtensionData.Summary.UsageSummary.TotalMemCapacityMB}},@{N='MemReservationMB';E={$_.ExtensionData.Summary.UsageSummary.MemReservationMB}},@{N='MemDemandMB';E={$_.ExtensionData.Summary.UsageSummary.MemDemandMB}},@{N='MemEntitled';E={$_.ExtensionData.Summary.UsageSummary.MemEntitledMB}} | FT
#$ClusterMem

$clusters = Get-Cluster | Where {($_.Name -ne 'Staging')}

$Obj = @()
Foreach($Cluster in $Clusters){
$ClusterCPU = Get-Cluster $cluster | Select @{N='Cluster';E={$cluster.Name}},@{N='CPUCapacity';E={$_.ExtensionData.Summary.UsageSummary.TotalCpuCapacityMhz}},@{N='CPUReservation';E={$_.ExtensionData.Summary.UsageSummary.CpuReservationMhz}},@{N='CPUDemand';E={$_.ExtensionData.Summary.UsageSummary.CpuDemandMhz}},@{N='CPUEntitled';E={$_.ExtensionData.Summary.UsageSummary.CpuEntitledMhz}}
				
$ClusterName = ($Cluster).Name
$ClusterCPURes = ($ClusterCPU).CPUReservation
$ClusterCPUCap = ($ClusterCPU).CPUCapacity
$ClusterCPUDem = ($ClusterCPU).CPUDemand
$ClusterCPUEnt = ($ClusterCPU).CPUEntitled
#$ClusterCPUAvail = (($ClusterCPUCap)-($ClusterCPUEnt))
$ClusterCPUAvail = (($ClusterCPUCap)-($ClusterCPURes))
$ClusterCPUAvailPer = [Math]::Round((($ClusterCPUAvail)/($ClusterCPUCap)*100),2)
$ClusterCPUAvailPercent = "$ClusterCPUAvailPer" + "%"

$stat = 'cpu.ready.summation'
$esx = Get-Cluster -Name $cluster | Get-VMHost
$stats = Get-Stat -Entity $esx -Stat $stat -Realtime -MaxSamples 1 -Instance ""
$readyAvg = $stats | Measure-Object -Property Value -Average | select -ExpandProperty Average
$readyPerc = [Math]::Round(($readyAvg / ($stats[0].IntervalSecs * 1000)),2)
$ClusterReady = "$readyPerc" + "%"

$ComputeObj = new-object psobject -Property @{
				ClusterName = $ClusterName
				ClusterCPUCapacity = $ClusterCPUCap
				ClusterCPUReserved = $ClusterCPURes
				ClusterCPUDemand = $ClusterCPUDem
				ClusterCPUEntitlement = $ClusterCPUEnt
				ClusterCPUAvailable = $ClusterCPUAvail
				ClusterCPUAvailablePercent = $ClusterCPUAvailPercent
				ClusterReadyPercent = $ClusterReady
				}
$Obj += $computeObj
}
write-output $Obj | Select ClusterName,ClusterCPUCapacity,ClusterCPUReserved,ClusterCPUDemand,ClusterCPUEntitlement,ClusterCPUAvailable,ClusterCPUAvailablePercent,ClusterReadyPercent

#Get Cluster CPU Stats
#$ClusterMEM = Get-Cluster -PipelineVariable cluster | Select @{N='Cluster';E={$cluster.Name}},@{N='CPU Capacity';E={$_.ExtensionData.Summary.UsageSummary.TotalCpuCapacityMhz}},@{N='CPU Reservation';E={$_.ExtensionData.Summary.UsageSummary.CpuReservationMhz}}


#CpuDemandMhz
#CpuEntitledMhz