#Select the cluster for data gathering
$Cluster = (Get-Cluster | Sort-Object -Property Name).Name
$countCL = 0
Write-Output " "
Write-Output "Clusters: "
Write-Output " "
foreach($oC in $Cluster){
Write-Output "[$countCL] $oc"
$countCL = $countCL+1
}
Write-Output " "
$choice = Read-Host "Which cluster would you like to review?"
Write-Output " "
# Write-host "please wait for script to finish, it may take some minutes." -ForegroundColor Yellow
$cluster = get-cluster $cluster[$choice]
$choice = 0

#Get Host CPU total MHz for cluster
$ESXHosts = Get-Cluster $cluster | Get-VMHost
$ESXComputeTotal = @()
ForEach ($EsxHost in $ESXhosts){
$ESXCompute = (Get-VMHost $ESXHost).CpuTotalMHz
$ESXComputeTotal += $ESXCompute
}
$ClusterCompute = ($ESXComputeTotal | Measure-Object -Sum).Sum

#Get Host CPU MHz used numbers for cluster
$ESXHosts = Get-Cluster $cluster | Get-VMHost
$ESXComputeUsedTotal = @()
ForEach ($EsxHost in $ESXhosts){
$ESXComputeUsed = (Get-VMHost $ESXHost).cpuusagemhz
$ESXComputeUsedTotal += $ESXComputeUsed
}
$ClusterComputeUsed = ($ESXComputeUsedTotal | Measure-Object -Sum).Sum


#Get Non-empty Flexible Resource Pools
$FRPs = Get-Cluster $cluster | Get-ResourcePool | Where-Object {($_.CPULimitMHz -ne "0") -and ($_.MemLimitGB -eq "-1") -and ($_.CPUReservationMHz -ne "0")} 

#Get FRP Compute Stats
$FRPMHzLimit = @()
ForEach ($RP in $RPs){
$RPName = $RP.Name
$RPCPURes = $RP.CPUReservationMHz
$RPCPUresNoZero = $RPCPUres | Where-Object {($_.CPUReservationMHz -ne 0)}
$RPCPULimit = $RP.CPULimitMHz
#$RPCPUlimitNoZero = $RPCPUlimit | Where-Object {($_.CPUlimitMHz -ne 0)}
#$FRPCPULimit = [Math]::Round(($RPCPULimit/(1/3),2))
$FRPCPULimit = [Math]::Round(($RPCPULimit*($RPCPUres/$RPCPULimit)),0)
$obj = new-object psobject -Property @{
			RPName = $RPName
			RPCPURes = $RPCPURes
			RPCPULimit = $RPCPULimit 
			FRPCPULimit = $FRPCPULimit 
				}
		$returnObj += $obj
}
#write-output $returnObj | where ({$_.RPCPURES -eq $FRPCPULimit}) | Select RPName,RPCPURes,FRPCPULimit,RPCPULimit
write-output $returnObj | Select RPName,RPCPURes,FRPCPULimit,RPCPULimit



Get-ResourcePool | Where-Object {($_.CPULimitMHz -ne "-1") -and ($_.MemLimitGB -ne "-1")}
