#Capture process start time
$startTime = get-date 

#Import required modules:
Import-Module ImportExcel

#Define global variables
$resourcePool = 'A81ZA vDC DTW_01 (f4cae1b3-4449-4b4d-963c-6449ba818c60)'
$fulldate = get-date -format yyyy-MM-dd
$month = (Get-Culture).DateTimeFormat.GetMonthName((Get-Date).Month)
$mo = get-date -format MM
$year = get-date -format yyyy
$day = get-date -format dd
$time = get-date -uformat %R
$filename = "C:\PAYG_Stat_Collection\A81ZA_DTW01\A81ZA_DTW01" + "_"+  "$year" + "-" + "$month" + ".xlsx"
$worksheet = $fulldate

#Connect to vCenter
$connect = Connect-VIServer vmw-mgmt-vc02.vdc.local

#Collect Stats:
Get-ResourcePool -Name $resourcePool | Get-VM | Foreach {Add-Member -InputObject $_ -MemberType NoteProperty -Name Year -Value $year -PassThru} | Foreach {Add-Member -InputObject $_ -MemberType NoteProperty -Name Month -Value $month -PassThru} |Foreach {Add-Member -InputObject $_ -MemberType NoteProperty -Name Day -Value $day -PassThru} | Foreach {Add-Member -InputObject $_ -MemberType NoteProperty -Name Time -Value $time -PassThru} | Select Year, Month, Day, Time, Name,PowerState, NumCpu, MemoryGB, @{N="Resource Pool";E={Get-ResourcePool -VM $_}},ProvisionedSpaceGB, UsedSpaceGB,@{N="Datacenter";E={Get-Datacenter -VM $_}}, @{N="Cluster";E={Get-Cluster -VM $_}},@{N="Datastore";E={Get-Datastore -VM $_}} | export-excel $filename -worksheetname $worksheet -startcolumn 2 -Autosize -startrow 3 -append


#Disconnect from all vCenters
Disconnect-VIServer -Server * -Force -Confirm:$false

#Calculate time required to execute script
$EndTime = get-date 
$Duration = $EndTime-$StartTime

#Append runtime info to log file
echo " " >> "C:\PAYG_Stat_Collection\A81ZA_DTW01\A81ZA_DTW01_log.txt"
echo "--------------------------------" >> "C:\PAYG_Stat_Collection\A81ZA_DTW01\A81ZA_DTW01_log.txt"
echo "$FullDate" >> "C:\PAYG_Stat_Collection\A81ZA_DTW01\A81ZA_DTW01_log.txt"
echo " " >> "C:\PAYG_Stat_Collection\A81ZA_DTW01\A81ZA_DTW01_log.txt"
echo "Started: $StartTime" >> "C:\PAYG_Stat_Collection\A81ZA_DTW01\A81ZA_DTW01_log.txt"
echo "Completed: $EndTime" >> "C:\PAYG_Stat_Collection\A81ZA_DTW01\A81ZA_DTW01_log.txt"
echo "Completed in $duration" >> "C:\PAYG_Stat_Collection\A81ZA_DTW01\A81ZA_DTW01_log.txt"
echo "--------------------------------" >> "C:\PAYG_Stat_Collection\A81ZA_DTW01\A81ZA_DTW01_log.txt"
