$VMhosts = Get-VMHost
$DaysBack = 14	#Define days back to calculate this value
$Start = (get-date).AddDays(-$DaysBack)
$Finish = get-date
$scriptpath = $MyInvocation.MyCommand.Path
$dir = Split-Path $scriptpath
$CSV = "$dir\Average_CPU_Usage_Peak_Hours.csv"
$PeakTimeStart = 8 #hour of the day in 24 hour format 
$PeakTimeEnd = 20 #hour of the day in 24 hour format
$rdy_interval = 7200 #interval of rdy time values aggregation/averaging in seconds. This value should be changed according to your vcenter statistics settings.
$VMs = (Get-VM | where {$_.PowerState -eq "PoweredOn"}).Name
#echo $VMs > vm_names.txt	
#	ForEach ($VM in get-content .\vm_names.txt){
#	#Get-VM  | where {$_.PowerState -eq "PoweredOn"} | Get-Stat -Stat cpu.ready.summation -Realtime -MaxSamples 1 -Instance ""
#	$stats = get-vm $VM | Get-Stat -realtime -maxsamples 1 -Stat Cpu.Ready.Summation #-Instance "" 
#	$aggr_stats = $stats | Measure-Object -Property Value -Average 
#	$rdy = [Math]::Round(((($aggr_stats.Average)/1000)/20) * 100,1)
#	return $rdy
#	}

$returnObj = @()	
foreach($line in [System.IO.File]::ReadLines("C:\users\tverkade\Desktop\vm_names2.txt"))
{
       
	   $stats = get-vm $line | Get-Stat -realtime -maxsamples 1 -Stat Cpu.Ready.Summation #-Instance ""
	   $aggr_stats = $stats | Measure-Object -Property Value -Average 
       $rdy = [Math]::Round(((($aggr_stats.Average)/1000)/20) * 100,1)
	   #$VMstats = $line += $rdy
	
	   $obj = new-object psobject -Property @{
				VMName = $line
				CPUReady = $rdy
				}
			#$VMstats | Format-Table VMName,CPUReady
		$returnObj += $obj | Select VMName,CPUReady
}
$returnObj | Export-CSV CPU_Ready.csv -NoTypeInformation