#Begin
Import-Module ImportExcel

#Variables
	#UCS Domains
		$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
		$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
		$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
		$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
		$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
		$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70
		
	#Credentials
		$c = Get-Credential

	#Misc Names
		$date = get-date -format yyyy-MM-dd
		$filename = ".\UCS_Report_$date.xlsx"
		$date = get-date -format yyyy-MM-dd
		$ucs = "blank"

#Define UCS domains
$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70

#Connect and Collect
Connect-Ucs $kwd1 -Credential $c
$ucs = (get-ucschassis | Get-UcsBlade | select Ucs | Select-Object -first 1).ucs
$worksheetname = $ucs
#get-ucschassis | Get-UcsBlade | select ChassisId,SlotId,AssignedTolbl,UsrLbl,Model,Vid,Serial,Association,TotalMemory,NumOfCpus,NumOfCores,Ucs | Export-CSV UCS_report.csv -append -NoTypeInformation

# Set up output file
echo "Chassis 1" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 1
#odd slots
echo "User Label" | export-excel $filename -worksheetname $worksheetname  -startcolumn 2 -startrow 2
echo "Blade Model" | export-excel $filename -worksheetname $worksheetname  -startcolumn 2 -startrow 3
echo "Slot 1" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 3
echo "Slot 3" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 4
echo "Slot 5" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 5
echo "Slot 7" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 6
#even slots
echo "User Label" | export-excel $filename -worksheetname $worksheetname  -startcolumn 5 -startrow 2
echo "Blade Model" | export-excel $filename -worksheetname $worksheetname  -startcolumn 6 -startrow 2
echo "Slot 2" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 3
echo "Slot 4" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 4
echo "Slot 6" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 5
echo "Slot 8" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 6

# Set up output file
echo "Chassis 10" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 8
#odd slots
echo "User Label" | export-excel $filename -worksheetname $worksheetname  -startcolumn 2 -startrow 9
echo "Blade Model" | export-excel $filename -worksheetname $worksheetname  -startcolumn 2 -startrow 10
echo "Slot 1" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 11
echo "Slot 3" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 12
echo "Slot 5" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 13
echo "Slot 7" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 14
#even slots
echo "User Label" | export-excel $filename -worksheetname $worksheetname  -startcolumn 5 -startrow 9
echo "Blade Model" | export-excel $filename -worksheetname $worksheetname  -startcolumn 6 -startrow 9
echo "Slot 2" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 11
echo "Slot 4" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 12
echo "Slot 6" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 13
echo "Slot 8" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 14



#get-ucschassis | Get-UcsBlade | Where-Object {$_.ChassisID -eq "1"} and ($_.SlotID -eq '7')

#Chassis 1
#odd
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '1')} ).UsrLbl 
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '1')} ).model 
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 3
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 3
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '3')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '3')} ).model 
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 4
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 4
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '5')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '5')} ).model
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 5
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 5
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '7')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '7')} ).model
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 6
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 6
#even                                                                                                         
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '2')} ).UsrLbl 
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '2')} ).model 
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 3
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 3
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '4')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '4')} ).model 
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 4
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 4
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '6')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '6')} ).model
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 5
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 5
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '8')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '8')} ).model
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 6
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 6

#Chassis 10
#odd
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '1')} ).UsrLbl 
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '1')} ).model 
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 11
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 11
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '3')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '3')} ).model 
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 12
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 12
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '5')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '5')} ).model
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 13
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 13
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '7')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '7')} ).model
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 14
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 14
#even                                                                                                         
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '2')} ).UsrLbl 
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '2')} ).model 
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 11
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 11
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '4')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '4')} ).model 
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 12
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 12
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '6')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '6')} ).model
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 13
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 13
$lbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '8')} ).UsrLbl
$model = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '8')} ).model
echo $lbl | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 14
echo $model | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 14

Disconnect-Ucs