#Begin
Import-Module ImportExcel

#Variables
	#UCS Domains
		$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
		$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
		$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
		$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
		$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
		$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70
		
	#Credentials
		$c = Get-Credential

	#Misc Names
		$date = get-date -format yyyy-MM-dd
		$filename = ".\UCS_Report_$date.xlsx"
		$date = get-date -format yyyy-MM-dd
		$ucs = "blank"

#Define UCS domains
$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70

#Connect and Collect
Connect-Ucs $kwd1 -Credential $c
$ucs = (get-ucschassis | Get-UcsBlade | select Ucs | Select-Object -first 1).ucs
$worksheetname = $ucs
#get-ucschassis | Get-UcsBlade | select ChassisId,SlotId,AssignedTodn,AssignedToDn,Model,Vid,Serial,Association,TotalMemory,NumOfCpus,NumOfCores,Ucs | Export-CSV UCS_report.csv -append -NoTypeInformation

# Set up output file
echo "Chassis 1" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 1
#odd slots
echo "Profile Assigned" | export-excel $filename -worksheetname $worksheetname  -startcolumn 2 -startrow 2
echo "Slot 1" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 3
echo "Slot 3" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 4
echo "Slot 5" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 5
echo "Slot 7" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 6
#even slots
echo "Profile Assigned" | export-excel $filename -worksheetname $worksheetname  -startcolumn 5 -startrow 2
echo "Slot 2" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 3
echo "Slot 4" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 4
echo "Slot 6" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 5
echo "Slot 8" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 6

# Set up output file
echo "Chassis 10" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 8
#odd slots
echo "Profile Assigned" | export-excel $filename -worksheetname $worksheetname  -startcolumn 2 -startrow 9
echo "Slot 1" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 10
echo "Slot 3" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 11
echo "Slot 5" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 12
echo "Slot 7" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 13
#even slot
echo "Profile Assigned" | export-excel $filename -worksheetname $worksheetname  -startcolumn 5 -startrow 9
echo "Slot 2" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 10
echo "Slot 4" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 11
echo "Slot 6" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 12
echo "Slot 8" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 13



#get-ucschassis | Get-UcsBlade | Where-Object {$_.ChassisID -eq "1"} and ($_.SlotID -eq '7')

#Chassis 1
#odd
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '1')} ).AssignedToDn 
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 3
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '3')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 4
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '5')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 5
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '7')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 6

#even                                                                                                         
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '2')} ).AssignedToDn 
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 3
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '4')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 4
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '6')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 5
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 1) -and ($_.SlotID -eq '8')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 6

#Chassis 10
#odd
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '1')} ).AssignedToDn 
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 10
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '3')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 11
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '5')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 12
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '7')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 13
#even                                                                                                         
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '2')} ).AssignedToDn 
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 10
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '4')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 11
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '6')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 12
$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq 10) -and ($_.SlotID -eq '8')} ).AssignedToDn
echo $dn | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 13

Disconnect-Ucs