#Begin
Import-Module ImportExcel

#Variables
	#UCS Domains
		$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
		$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
		$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
		$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
		$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
		$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70
	
		$UcsDomains = $kwd1,$kwd2,$kwd3,$dtw1,$dtw2,$dtw3
		
		#$UcsDomains = $kwd2
		
	#Credentials
	$c = Get-Credential
	$date = get-date -format yyyy-MM-dd


ForEach ($UCSDomain in $UCSDomains)
{
#Connect and Collect
Connect-Ucs $UCSDomain -Credential $c
$ucsboards = (Get-UcsBlade).Serial

#Collect UCS Blade Stats
$returnObj = @()
ForEach ($ucsboard in $ucsboards){
$UCSdn = (Get-UcsBlade -Serial $ucsboard | Get-UcsComputeBoard ).Dn
$UCSCpuType = (Get-UcsBlade -Serial $ucsboard | Get-UcsComputeBoard).CpuTypeDescription
$UCSModel = (Get-UcsBlade -Serial $ucsboard | Get-UcsComputeBoard).Model
$UCSSerial = (Get-UcsBlade -Serial $ucsboard | Get-UcsComputeBoard).Serial
$UCSdomain = (Get-UcsBlade -Serial $ucsboard | Get-UcsComputeBoard).Ucs
$BladeCPU1 = (Get-UcsBlade -Serial $ucsboard | Get-UcsComputeBoard | Get-UcsProcessorUnit | Where {$_.Rn -eq "cpu-1"}).Model
$BladeCPU2 = (Get-UcsBlade -Serial $ucsboard | Get-UcsComputeBoard | Get-UcsProcessorUnit | Where {$_.Rn -eq "cpu-2"}).Model


			$obj = new-object psobject -Property @{
			BladeDN = $UCSDn
			UCSDomain = $UCSDomain
			CPUType = $UCSCpuType
			CPU1 = $BladeCPU1
			CPU2 = $BladeCPU1
			BladeModel = $UCSModel
			BladeSerial = $UCSSerial
			}
		$returnObj += $obj | Select BladeDN,CPUType,CPU1,CPU2,BladeModel,UCSDomain,BladeSerial
}
write-output $returnObj | Sort-Object -Property BladeDN | Export-CSV UCS_BLADE_CPU_Info.csv -append -notypeinformation

#End connection to UCS
Disconnect-Ucs
}
