#Begin
Import-Module ImportExcel

#UCS Power Stats
#Get-UcsBlade | Get-UcsComputeBoard | Get-UcsComputeMbPowerStats

#Variables
	#UCS Domains
		$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
		$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
		$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
		$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
		$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
		$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70
		
	#Credentials
		$c = Get-Credential

	$date = get-date -format yyyy-MM-dd


#Connect and Collect
Connect-Ucs $kwd1 -Credential $c
$filename = ".\$KWD1" + "_Report_" + "$date.xlsx"
#$ucs = (get-ucschassis | Get-UcsBlade | select Ucs | Select-Object -first 1).ucs
$UCSchassis = (get-ucschassis | select Id).ID
#$worksheetname = 0
#get-ucschassis | Get-UcsBlade | select ChassisId,SlotId,AssignedTodn,AssignedToDn,Model,Vid,Serial,Association,TotalMemory,NumOfCpus,NumOfCores,Ucs | Export-CSV UCS_report.csv -append -NoTypeInformation


ForEach ($UCSChassisID in $UCSchassis){
	#Set up output file
	#$worksheetname = $UCSchassisID
	echo "Chassis #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 1 -AutoSize
	echo $UCSchassisID | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 1  -AutoSize
	#odd slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 2
	echo "Slot 1" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 3 -AutoSize
	echo "Slot 3" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 4 -AutoSize
	echo "Slot 5" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 5 -AutoSize
	echo "Slot 7" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 6 -AutoSize
	#even slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 2 -AutoSize
	echo "Slot 2" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 3 -AutoSize
	echo "Slot 4" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 4 -AutoSize
	echo "Slot 6" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 5 -AutoSize
	echo "Slot 8" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 6 -AutoSize
	
	#Set up columns for individual blade information
	echo "Blade" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 8 -AutoSize
	echo "Assigned Profile" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 8 -AutoSize
	echo "User Label" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 3 -startrow 8 -AutoSize
	echo "Model" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 8 -AutoSize
	echo "VID" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 5 -startrow 8 -AutoSize
	echo "Serial #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 6 -startrow 8 -AutoSize
	echo "Association Status" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 7 -startrow 8 -AutoSize
	echo "Total RAM" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 8 -startrow 8 -AutoSize
	echo "CPUs Installed" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 9 -startrow 8 -AutoSize
	echo "CPU Cores" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 10 -startrow 8 -AutoSize
	echo "UCS Domain" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 11 -startrow 8 -AutoSize
	
	$OddBlade = "Blank"
	$EvenBladedn = "Blank"
	$BladeAssignedToDn = "blank"
	$BladeUsrLbl = "blank"
	$BladeModel = "blank"
	$BladeVid = "blank"
	$BladeSerial = "blank"
	$BladeAssociation = "blank"
	$BladeTotalMemory = "blank"
	$BladeNumOfCpus = "blank"
	$BladeNumOfCores = "blank"
	$BladeSlotID = 0
		
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 3)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 4 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 5)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 5 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 7)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 6 -Autosize
	
	
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 4)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 4 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 6)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 5 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 8)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 6 -Autosize

	
	#Grab Slot Information
	#if(get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)})
	#	{
	#	$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)}.AssignedToDn)
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3
	#	}
	
	#if($dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2 -or $_.SlotID -eq 4 -or $_.SlotID -eq 6 -or $_.SlotID -eq 8)}).AssignedToDn) 
	#	{
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3
	#	}
		
	#Grab Blade Information
	$BladeSlotID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).SlotID
	echo $BladeSlotID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 1 -startrow 9 -AutoSize
	
	$BladeAssignedToDn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).AssignedToDn 
	echo $BladeAssignedToDn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 9 -AutoSize
	
	$BladeUsrLbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).UsrLbl 
	echo $BladeUsrLbl | export-excel $filename -worksheetname $UCSchassisID -startcolumn 3 -startrow 9 -AutoSize

	$BladeModel = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Model 
	echo $BladeModel | export-excel $filename -worksheetname $UCSchassisID -startcolumn 4 -startrow 9 -AutoSize
	
	$BladeVID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).VID 
	echo $BladeVID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 9	-AutoSize
	
	$BladeSerial = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Serial 
	echo $BladeSerial | export-excel $filename -worksheetname $UCSchassisID -startcolumn 6 -startrow 9 -AutoSize
	
	$BladeAssociation = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Association
	echo $BladeAssociation | export-excel $filename -worksheetname $UCSchassisID -startcolumn 7 -startrow 9 -AutoSize
	
	$BladeTotalMemory = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).TotalMemory
	echo $BladeTotalMemory | export-excel $filename -worksheetname $UCSchassisID -startcolumn 8 -startrow 9 -AutoSize
	
	$BladeNumOfCpus = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCpus
	echo $BladeNumOfCpus | export-excel $filename -worksheetname $UCSchassisID -startcolumn 9 -startrow 9 -AutoSize
	
	$BladeNumOfCores = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCores
	echo $BladeNumOfCores | export-excel $filename -worksheetname $UCSchassisID -startcolumn 10 -startrow 9 -AutoSize
	 
	$BladeMkt = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Ucs
	echo $BladeMkt | export-excel $filename -worksheetname $UCSchassisID -startcolumn 11 -startrow 9 -AutoSize

}
Disconnect-Ucs


#Connect and Collect
Connect-Ucs $kwd2 -Credential $c
$filename = ".\$KWD2" + "_Report_" + "$date.xlsx"
#$ucs = (get-ucschassis | Get-UcsBlade | select Ucs | Select-Object -first 1).ucs
$UCSchassis = (get-ucschassis | select Id).ID
#$worksheetname = 0
#get-ucschassis | Get-UcsBlade | select ChassisId,SlotId,AssignedTodn,AssignedToDn,Model,Vid,Serial,Association,TotalMemory,NumOfCpus,NumOfCores,Ucs | Export-CSV UCS_report.csv -append -NoTypeInformation

ForEach ($UCSChassisID in $UCSchassis){
	#Set up output file
	#$worksheetname = $UCSchassisID
	echo "Chassis #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 1 -AutoSize
	echo $UCSchassisID | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 1  -AutoSize
	#odd slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 2
	echo "Slot 1" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 3 -AutoSize
	echo "Slot 3" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 4 -AutoSize
	echo "Slot 5" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 5 -AutoSize
	echo "Slot 7" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 6 -AutoSize
	#even slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 2 -AutoSize
	echo "Slot 2" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 3 -AutoSize
	echo "Slot 4" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 4 -AutoSize
	echo "Slot 6" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 5 -AutoSize
	echo "Slot 8" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 6 -AutoSize
	
	#Set up columns for individual blade information
	echo "Blade" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 8 -AutoSize
	echo "Assigned Profile" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 8 -AutoSize
	echo "User Label" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 3 -startrow 8 -AutoSize
	echo "Model" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 8 -AutoSize
	echo "VID" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 5 -startrow 8 -AutoSize
	echo "Serial #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 6 -startrow 8 -AutoSize
	echo "Association Status" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 7 -startrow 8 -AutoSize
	echo "Total RAM" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 8 -startrow 8 -AutoSize
	echo "CPUs Installed" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 9 -startrow 8 -AutoSize
	echo "CPU Cores" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 10 -startrow 8 -AutoSize
	echo "UCS Domain" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 11 -startrow 8 -AutoSize
	
	$OddBlade = "Blank"
	$EvenBladedn = "Blank"
	$BladeAssignedToDn = "blank"
	$BladeUsrLbl = "blank"
	$BladeModel = "blank"
	$BladeVid = "blank"
	$BladeSerial = "blank"
	$BladeAssociation = "blank"
	$BladeTotalMemory = "blank"
	$BladeNumOfCpus = "blank"
	$BladeNumOfCores = "blank"
	$BladeSlotID = 0
		
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 3)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 4 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 5)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 5 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 7)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 6 -Autosize
	
	
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 4)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 4 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 6)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 5 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 8)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 6 -Autosize

	
	#Grab Slot Information
	#if(get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)})
	#	{
	#	$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)}.AssignedToDn)
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3
	#	}
	
	#if($dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2 -or $_.SlotID -eq 4 -or $_.SlotID -eq 6 -or $_.SlotID -eq 8)}).AssignedToDn) 
	#	{
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3
	#	}
		
	#Grab Blade Information
	$BladeSlotID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).SlotID
	echo $BladeSlotID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 1 -startrow 9 -AutoSize
	
	$BladeAssignedToDn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).AssignedToDn 
	echo $BladeAssignedToDn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 9 -AutoSize
	
	$BladeUsrLbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).UsrLbl 
	echo $BladeUsrLbl | export-excel $filename -worksheetname $UCSchassisID -startcolumn 3 -startrow 9 -AutoSize

	$BladeModel = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Model 
	echo $BladeModel | export-excel $filename -worksheetname $UCSchassisID -startcolumn 4 -startrow 9 -AutoSize
	
	$BladeVID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).VID 
	echo $BladeVID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 9	-AutoSize
	
	$BladeSerial = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Serial 
	echo $BladeSerial | export-excel $filename -worksheetname $UCSchassisID -startcolumn 6 -startrow 9 -AutoSize
	
	$BladeAssociation = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Association
	echo $BladeAssociation | export-excel $filename -worksheetname $UCSchassisID -startcolumn 7 -startrow 9 -AutoSize
	
	$BladeTotalMemory = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).TotalMemory
	echo $BladeTotalMemory | export-excel $filename -worksheetname $UCSchassisID -startcolumn 8 -startrow 9 -AutoSize
	
	$BladeNumOfCpus = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCpus
	echo $BladeNumOfCpus | export-excel $filename -worksheetname $UCSchassisID -startcolumn 9 -startrow 9 -AutoSize
	
	$BladeNumOfCores = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCores
	echo $BladeNumOfCores | export-excel $filename -worksheetname $UCSchassisID -startcolumn 10 -startrow 9 -AutoSize
	 
	$BladeMkt = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Ucs
	echo $BladeMkt | export-excel $filename -worksheetname $UCSchassisID -startcolumn 11 -startrow 9 -AutoSize

}
Disconnect-Ucs

#Connect and Collect
Connect-Ucs $kwd3 -Credential $c
$filename = ".\$KWD3" + "_Report_" + "$date.xlsx"
#$ucs = (get-ucschassis | Get-UcsBlade | select Ucs | Select-Object -first 1).ucs
$UCSchassis = (get-ucschassis | select Id).ID
#$worksheetname = 0
#get-ucschassis | Get-UcsBlade | select ChassisId,SlotId,AssignedTodn,AssignedToDn,Model,Vid,Serial,Association,TotalMemory,NumOfCpus,NumOfCores,Ucs | Export-CSV UCS_report.csv -append -NoTypeInformation

ForEach ($UCSChassisID in $UCSchassis){
	#Set up output file
	#$worksheetname = $UCSchassisID
	echo "Chassis #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 1 -AutoSize
	echo $UCSchassisID | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 1  -AutoSize
	#odd slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 2
	echo "Slot 1" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 3 -AutoSize
	echo "Slot 3" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 4 -AutoSize
	echo "Slot 5" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 5 -AutoSize
	echo "Slot 7" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 6 -AutoSize
	#even slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 2 -AutoSize
	echo "Slot 2" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 3 -AutoSize
	echo "Slot 4" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 4 -AutoSize
	echo "Slot 6" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 5 -AutoSize
	echo "Slot 8" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 6 -AutoSize
	
	#Set up columns for individual blade information
	echo "Blade" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 8 -AutoSize
	echo "Assigned Profile" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 8 -AutoSize
	echo "User Label" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 3 -startrow 8 -AutoSize
	echo "Model" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 8 -AutoSize
	echo "VID" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 5 -startrow 8 -AutoSize
	echo "Serial #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 6 -startrow 8 -AutoSize
	echo "Association Status" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 7 -startrow 8 -AutoSize
	echo "Total RAM" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 8 -startrow 8 -AutoSize
	echo "CPUs Installed" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 9 -startrow 8 -AutoSize
	echo "CPU Cores" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 10 -startrow 8 -AutoSize
	echo "UCS Domain" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 11 -startrow 8 -AutoSize
	
	$OddBlade = "Blank"
	$EvenBladedn = "Blank"
	$BladeAssignedToDn = "blank"
	$BladeUsrLbl = "blank"
	$BladeModel = "blank"
	$BladeVid = "blank"
	$BladeSerial = "blank"
	$BladeAssociation = "blank"
	$BladeTotalMemory = "blank"
	$BladeNumOfCpus = "blank"
	$BladeNumOfCores = "blank"
	$BladeSlotID = 0
		
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 3)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 4 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 5)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 5 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 7)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 6 -Autosize
	
	
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 4)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 4 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 6)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 5 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 8)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 6 -Autosize

	
	#Grab Slot Information
	#if(get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)})
	#	{
	#	$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)}.AssignedToDn)
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3
	#	}
	
	#if($dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2 -or $_.SlotID -eq 4 -or $_.SlotID -eq 6 -or $_.SlotID -eq 8)}).AssignedToDn) 
	#	{
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3
	#	}
		
	#Grab Blade Information
	$BladeSlotID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).SlotID
	echo $BladeSlotID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 1 -startrow 9 -AutoSize
	
	$BladeAssignedToDn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).AssignedToDn 
	echo $BladeAssignedToDn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 9 -AutoSize
	
	$BladeUsrLbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).UsrLbl 
	echo $BladeUsrLbl | export-excel $filename -worksheetname $UCSchassisID -startcolumn 3 -startrow 9 -AutoSize

	$BladeModel = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Model 
	echo $BladeModel | export-excel $filename -worksheetname $UCSchassisID -startcolumn 4 -startrow 9 -AutoSize
	
	$BladeVID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).VID 
	echo $BladeVID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 9	-AutoSize
	
	$BladeSerial = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Serial 
	echo $BladeSerial | export-excel $filename -worksheetname $UCSchassisID -startcolumn 6 -startrow 9 -AutoSize
	
	$BladeAssociation = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Association
	echo $BladeAssociation | export-excel $filename -worksheetname $UCSchassisID -startcolumn 7 -startrow 9 -AutoSize
	
	$BladeTotalMemory = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).TotalMemory
	echo $BladeTotalMemory | export-excel $filename -worksheetname $UCSchassisID -startcolumn 8 -startrow 9 -AutoSize
	
	$BladeNumOfCpus = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCpus
	echo $BladeNumOfCpus | export-excel $filename -worksheetname $UCSchassisID -startcolumn 9 -startrow 9 -AutoSize
	
	$BladeNumOfCores = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCores
	echo $BladeNumOfCores | export-excel $filename -worksheetname $UCSchassisID -startcolumn 10 -startrow 9 -AutoSize
	 
	$BladeMkt = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Ucs
	echo $BladeMkt | export-excel $filename -worksheetname $UCSchassisID -startcolumn 11 -startrow 9 -AutoSize

}
Disconnect-Ucs

#Connect and Collect
Connect-Ucs $DTW1 -Credential $c
$filename = ".\$DTW1" + "_Report_" + "$date.xlsx"
#$ucs = (get-ucschassis | Get-UcsBlade | select Ucs | Select-Object -first 1).ucs
$UCSchassis = (get-ucschassis | select Id).ID
#$worksheetname = 0
#get-ucschassis | Get-UcsBlade | select ChassisId,SlotId,AssignedTodn,AssignedToDn,Model,Vid,Serial,Association,TotalMemory,NumOfCpus,NumOfCores,Ucs | Export-CSV UCS_report.csv -append -NoTypeInformation

ForEach ($UCSChassisID in $UCSchassis){
	#Set up output file
	#$worksheetname = $UCSchassisID
	echo "Chassis #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 1 -AutoSize
	echo $UCSchassisID | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 1  -AutoSize
	#odd slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 2
	echo "Slot 1" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 3 -AutoSize
	echo "Slot 3" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 4 -AutoSize
	echo "Slot 5" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 5 -AutoSize
	echo "Slot 7" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 6 -AutoSize
	#even slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 2 -AutoSize
	echo "Slot 2" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 3 -AutoSize
	echo "Slot 4" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 4 -AutoSize
	echo "Slot 6" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 5 -AutoSize
	echo "Slot 8" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 6 -AutoSize
	
	#Set up columns for individual blade information
	echo "Blade" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 8 -AutoSize
	echo "Assigned Profile" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 8 -AutoSize
	echo "User Label" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 3 -startrow 8 -AutoSize
	echo "Model" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 8 -AutoSize
	echo "VID" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 5 -startrow 8 -AutoSize
	echo "Serial #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 6 -startrow 8 -AutoSize
	echo "Association Status" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 7 -startrow 8 -AutoSize
	echo "Total RAM" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 8 -startrow 8 -AutoSize
	echo "CPUs Installed" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 9 -startrow 8 -AutoSize
	echo "CPU Cores" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 10 -startrow 8 -AutoSize
	echo "UCS Domain" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 11 -startrow 8 -AutoSize
	
	$OddBlade = "Blank"
	$EvenBladedn = "Blank"
	$BladeAssignedToDn = "blank"
	$BladeUsrLbl = "blank"
	$BladeModel = "blank"
	$BladeVid = "blank"
	$BladeSerial = "blank"
	$BladeAssociation = "blank"
	$BladeTotalMemory = "blank"
	$BladeNumOfCpus = "blank"
	$BladeNumOfCores = "blank"
	$BladeSlotID = 0
		
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 3)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 4 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 5)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 5 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 7)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 6 -Autosize
	
	
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 4)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 4 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 6)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 5 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 8)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 6 -Autosize

	
	#Grab Slot Information
	#if(get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)})
	#	{
	#	$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)}.AssignedToDn)
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3
	#	}
	
	#if($dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2 -or $_.SlotID -eq 4 -or $_.SlotID -eq 6 -or $_.SlotID -eq 8)}).AssignedToDn) 
	#	{
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3
	#	}
		
	#Grab Blade Information
	$BladeSlotID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).SlotID
	echo $BladeSlotID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 1 -startrow 9 -AutoSize
	
	$BladeAssignedToDn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).AssignedToDn 
	echo $BladeAssignedToDn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 9 -AutoSize
	
	$BladeUsrLbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).UsrLbl 
	echo $BladeUsrLbl | export-excel $filename -worksheetname $UCSchassisID -startcolumn 3 -startrow 9 -AutoSize

	$BladeModel = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Model 
	echo $BladeModel | export-excel $filename -worksheetname $UCSchassisID -startcolumn 4 -startrow 9 -AutoSize
	
	$BladeVID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).VID 
	echo $BladeVID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 9	-AutoSize
	
	$BladeSerial = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Serial 
	echo $BladeSerial | export-excel $filename -worksheetname $UCSchassisID -startcolumn 6 -startrow 9 -AutoSize
	
	$BladeAssociation = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Association
	echo $BladeAssociation | export-excel $filename -worksheetname $UCSchassisID -startcolumn 7 -startrow 9 -AutoSize
	
	$BladeTotalMemory = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).TotalMemory
	echo $BladeTotalMemory | export-excel $filename -worksheetname $UCSchassisID -startcolumn 8 -startrow 9 -AutoSize
	
	$BladeNumOfCpus = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCpus
	echo $BladeNumOfCpus | export-excel $filename -worksheetname $UCSchassisID -startcolumn 9 -startrow 9 -AutoSize
	
	$BladeNumOfCores = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCores
	echo $BladeNumOfCores | export-excel $filename -worksheetname $UCSchassisID -startcolumn 10 -startrow 9 -AutoSize
	 
	$BladeMkt = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Ucs
	echo $BladeMkt | export-excel $filename -worksheetname $UCSchassisID -startcolumn 11 -startrow 9 -AutoSize

}
Disconnect-Ucs



#Connect and Collect
Connect-Ucs $DTW2 -Credential $c
$filename = ".\$DTW2" + "_Report_" + "$date.xlsx"
#$ucs = (get-ucschassis | Get-UcsBlade | select Ucs | Select-Object -first 1).ucs
$UCSchassis = (get-ucschassis | select Id).ID
#$worksheetname = 0
#get-ucschassis | Get-UcsBlade | select ChassisId,SlotId,AssignedTodn,AssignedToDn,Model,Vid,Serial,Association,TotalMemory,NumOfCpus,NumOfCores,Ucs | Export-CSV UCS_report.csv -append -NoTypeInformation

ForEach ($UCSChassisID in $UCSchassis){
	#Set up output file
	#$worksheetname = $UCSchassisID
	echo "Chassis #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 1 -AutoSize
	echo $UCSchassisID | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 1  -AutoSize
	#odd slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 2
	echo "Slot 1" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 3 -AutoSize
	echo "Slot 3" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 4 -AutoSize
	echo "Slot 5" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 5 -AutoSize
	echo "Slot 7" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 6 -AutoSize
	#even slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 2 -AutoSize
	echo "Slot 2" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 3 -AutoSize
	echo "Slot 4" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 4 -AutoSize
	echo "Slot 6" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 5 -AutoSize
	echo "Slot 8" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 6 -AutoSize
	
	#Set up columns for individual blade information
	echo "Blade" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 8 -AutoSize
	echo "Assigned Profile" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 8 -AutoSize
	echo "User Label" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 3 -startrow 8 -AutoSize
	echo "Model" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 8 -AutoSize
	echo "VID" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 5 -startrow 8 -AutoSize
	echo "Serial #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 6 -startrow 8 -AutoSize
	echo "Association Status" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 7 -startrow 8 -AutoSize
	echo "Total RAM" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 8 -startrow 8 -AutoSize
	echo "CPUs Installed" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 9 -startrow 8 -AutoSize
	echo "CPU Cores" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 10 -startrow 8 -AutoSize
	echo "UCS Domain" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 11 -startrow 8 -AutoSize
	
	$OddBlade = "Blank"
	$EvenBladedn = "Blank"
	$BladeAssignedToDn = "blank"
	$BladeUsrLbl = "blank"
	$BladeModel = "blank"
	$BladeVid = "blank"
	$BladeSerial = "blank"
	$BladeAssociation = "blank"
	$BladeTotalMemory = "blank"
	$BladeNumOfCpus = "blank"
	$BladeNumOfCores = "blank"
	$BladeSlotID = 0
		
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 3)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 4 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 5)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 5 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 7)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 6 -Autosize
	
	
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 4)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 4 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 6)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 5 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 8)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 6 -Autosize

	
	#Grab Slot Information
	#if(get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)})
	#	{
	#	$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)}.AssignedToDn)
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3
	#	}
	
	#if($dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2 -or $_.SlotID -eq 4 -or $_.SlotID -eq 6 -or $_.SlotID -eq 8)}).AssignedToDn) 
	#	{
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3
	#	}
		
	#Grab Blade Information
	$BladeSlotID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).SlotID
	echo $BladeSlotID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 1 -startrow 9 -AutoSize
	
	$BladeAssignedToDn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).AssignedToDn 
	echo $BladeAssignedToDn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 9 -AutoSize
	
	$BladeUsrLbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).UsrLbl 
	echo $BladeUsrLbl | export-excel $filename -worksheetname $UCSchassisID -startcolumn 3 -startrow 9 -AutoSize

	$BladeModel = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Model 
	echo $BladeModel | export-excel $filename -worksheetname $UCSchassisID -startcolumn 4 -startrow 9 -AutoSize
	
	$BladeVID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).VID 
	echo $BladeVID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 9	-AutoSize
	
	$BladeSerial = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Serial 
	echo $BladeSerial | export-excel $filename -worksheetname $UCSchassisID -startcolumn 6 -startrow 9 -AutoSize
	
	$BladeAssociation = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Association
	echo $BladeAssociation | export-excel $filename -worksheetname $UCSchassisID -startcolumn 7 -startrow 9 -AutoSize
	
	$BladeTotalMemory = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).TotalMemory
	echo $BladeTotalMemory | export-excel $filename -worksheetname $UCSchassisID -startcolumn 8 -startrow 9 -AutoSize
	
	$BladeNumOfCpus = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCpus
	echo $BladeNumOfCpus | export-excel $filename -worksheetname $UCSchassisID -startcolumn 9 -startrow 9 -AutoSize
	
	$BladeNumOfCores = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCores
	echo $BladeNumOfCores | export-excel $filename -worksheetname $UCSchassisID -startcolumn 10 -startrow 9 -AutoSize
	 
	$BladeMkt = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Ucs
	echo $BladeMkt | export-excel $filename -worksheetname $UCSchassisID -startcolumn 11 -startrow 9 -AutoSize

}
Disconnect-Ucs



#Connect and Collect
Connect-Ucs $DTW3 -Credential $c
$filename = ".\$DTW3" + "_Report_" + "$date.xlsx"
#$ucs = (get-ucschassis | Get-UcsBlade | select Ucs | Select-Object -first 1).ucs
$UCSchassis = (get-ucschassis | select Id).ID
#$worksheetname = 0
#get-ucschassis | Get-UcsBlade | select ChassisId,SlotId,AssignedTodn,AssignedToDn,Model,Vid,Serial,Association,TotalMemory,NumOfCpus,NumOfCores,Ucs | Export-CSV UCS_report.csv -append -NoTypeInformation

ForEach ($UCSChassisID in $UCSchassis){
	#Set up output file
	#$worksheetname = $UCSchassisID
	echo "Chassis #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 1 -AutoSize
	echo $UCSchassisID | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 1  -AutoSize
	#odd slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 2
	echo "Slot 1" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 3 -AutoSize
	echo "Slot 3" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 4 -AutoSize
	echo "Slot 5" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 5 -AutoSize
	echo "Slot 7" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 6 -AutoSize
	#even slots
	echo "Profile Assigned" | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 2 -AutoSize
	echo "Slot 2" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 3 -AutoSize
	echo "Slot 4" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 4 -AutoSize
	echo "Slot 6" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 5 -AutoSize
	echo "Slot 8" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 6 -AutoSize
	
	#Set up columns for individual blade information
	echo "Blade" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 1 -startrow 8 -AutoSize
	echo "Assigned Profile" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 2 -startrow 8 -AutoSize
	echo "User Label" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 3 -startrow 8 -AutoSize
	echo "Model" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 4 -startrow 8 -AutoSize
	echo "VID" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 5 -startrow 8 -AutoSize
	echo "Serial #" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 6 -startrow 8 -AutoSize
	echo "Association Status" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 7 -startrow 8 -AutoSize
	echo "Total RAM" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 8 -startrow 8 -AutoSize
	echo "CPUs Installed" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 9 -startrow 8 -AutoSize
	echo "CPU Cores" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 10 -startrow 8 -AutoSize
	echo "UCS Domain" | export-excel $filename -worksheetname $UCSchassisID  -startcolumn 11 -startrow 8 -AutoSize
	
	$OddBlade = "Blank"
	$EvenBladedn = "Blank"
	$BladeAssignedToDn = "blank"
	$BladeUsrLbl = "blank"
	$BladeModel = "blank"
	$BladeVid = "blank"
	$BladeSerial = "blank"
	$BladeAssociation = "blank"
	$BladeTotalMemory = "blank"
	$BladeNumOfCpus = "blank"
	$BladeNumOfCores = "blank"
	$BladeSlotID = 0
		
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 3)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 4 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 5)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 5 -Autosize
	$OddBlade = "Blank"
	$OddBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 7)}).AssignedTodn
	echo $OddBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 6 -Autosize
	
	
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 4)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 4 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 6)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 5 -Autosize
	$EvenBlade = "Blank"
	$EvenBlade = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 8)}).AssignedTodn
	echo $EvenBlade | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 6 -Autosize

	
	#Grab Slot Information
	#if(get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)})
	#	{
	#	$dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 1 -or $_.SlotID -eq 3 -or $_.SlotID -eq 5 -or $_.SlotID -eq 7)}.AssignedToDn)
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 3
	#	}
	
	#if($dn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSchassisID) -and ($_.SlotID -eq 2 -or $_.SlotID -eq 4 -or $_.SlotID -eq 6 -or $_.SlotID -eq 8)}).AssignedToDn) 
	#	{
	#	echo $dn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 3
	#	}
		
	#Grab Blade Information
	$BladeSlotID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).SlotID
	echo $BladeSlotID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 1 -startrow 9 -AutoSize
	
	$BladeAssignedToDn = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).AssignedToDn 
	echo $BladeAssignedToDn | export-excel $filename -worksheetname $UCSchassisID -startcolumn 2 -startrow 9 -AutoSize
	
	$BladeUsrLbl = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).UsrLbl 
	echo $BladeUsrLbl | export-excel $filename -worksheetname $UCSchassisID -startcolumn 3 -startrow 9 -AutoSize

	$BladeModel = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Model 
	echo $BladeModel | export-excel $filename -worksheetname $UCSchassisID -startcolumn 4 -startrow 9 -AutoSize
	
	$BladeVID = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).VID 
	echo $BladeVID | export-excel $filename -worksheetname $UCSchassisID -startcolumn 5 -startrow 9	-AutoSize
	
	$BladeSerial = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Serial 
	echo $BladeSerial | export-excel $filename -worksheetname $UCSchassisID -startcolumn 6 -startrow 9 -AutoSize
	
	$BladeAssociation = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Association
	echo $BladeAssociation | export-excel $filename -worksheetname $UCSchassisID -startcolumn 7 -startrow 9 -AutoSize
	
	$BladeTotalMemory = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).TotalMemory
	echo $BladeTotalMemory | export-excel $filename -worksheetname $UCSchassisID -startcolumn 8 -startrow 9 -AutoSize
	
	$BladeNumOfCpus = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCpus
	echo $BladeNumOfCpus | export-excel $filename -worksheetname $UCSchassisID -startcolumn 9 -startrow 9 -AutoSize
	
	$BladeNumOfCores = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).NumOfCores
	echo $BladeNumOfCores | export-excel $filename -worksheetname $UCSchassisID -startcolumn 10 -startrow 9 -AutoSize
	 
	$BladeMkt = (get-ucschassis | Get-UcsBlade | Where-Object {($_.ChassisID -eq $UCSChassisID) } ).Ucs
	echo $BladeMkt | export-excel $filename -worksheetname $UCSchassisID -startcolumn 11 -startrow 9 -AutoSize

}
Disconnect-Ucs