#Begin
Import-Module ImportExcel

#Variables
	#UCS Domains
		$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
		$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
		$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
		$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
		$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
		$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70
		
	#Credentials
		$c = Get-Credential

	#Misc Names
		$date = get-date -format yyyy-MM-dd
		$filename = ".\UCS_Report_$date.xlsx"
		$date = get-date -format yyyy-MM-dd
		$ucs = "blank"

#Define UCS domains
$kwd1 = "UCS-gdrsmiuk.kwd.vdc.local"			#172.19.1.20	
$kwd2 = "UCS-gdrsmiuk-02.kwd.vdc.local"			#172.19.6.20	
$kwd3 = "UCS-gdrsmiuk-03.kwd.vdc.local"			#172.19.6.10	
$dtw1 = "UCS-MLRSMI00.dtw.vdc.local"			#172.16.50.60
$dtw2 = "UCS-MLRSMI00-02.dtw.vdc.local"			#172.16.54.60
$dtw3 = "UCS-MLRSMI00-03.dtw.vdc.local"			#172.16.54.70

#Connect and Collect
Connect-Ucs $kwd1 -Credential $c
$ucs = (get-ucschassis | Get-UcsBlade | select Ucs | Select-Object -first 1).ucs
$worksheetname = $ucs
#get-ucschassis | Get-UcsBlade | select ChassisId,SlotId,AssignedToDn,UsrLbl,Model,Vid,Serial,Association,TotalMemory,NumOfCpus,NumOfCores,Ucs | Export-CSV UCS_report.csv -append -NoTypeInformation

# Set up output file
echo "Chassis ID" | export-excel $filename -worksheetname $worksheetname  -startcolumn 1 -startrow 2
echo "Slot ID" | export-excel $filename -worksheetname $worksheetname  -startcolumn 2 -startrow 2
echo "AssignedToDn" | export-excel $filename -worksheetname $worksheetname  -startcolumn 3 -startrow 2
echo "UsrLbl" | export-excel $filename -worksheetname $worksheetname  -startcolumn 4 -startrow 2
echo "Model" | export-excel $filename -worksheetname $worksheetname  -startcolumn 5 -startrow 2
echo "Vid" | export-excel $filename -worksheetname $worksheetname  -startcolumn 6 -startrow 2
echo "Serial" | export-excel $filename -worksheetname $worksheetname  -startcolumn 7 -startrow 2
echo "Association" | export-excel $filename -worksheetname $worksheetname  -startcolumn 8 -startrow 2
echo "TotalMemory" | export-excel $filename -worksheetname $worksheetname  -startcolumn 9 -startrow 2
echo "NumOfCpus" | export-excel $filename -worksheetname $worksheetname  -startcolumn 10 -startrow 2
echo "NumOfCores" | export-excel $filename -worksheetname $worksheetname  -startcolumn 11 -startrow 2
echo "Ucs" | export-excel $filename -worksheetname $worksheetname  -startcolumn 12 -startrow 2

$bladeinfo = get-ucschassis | Get-UcsBlade
echo $bladeinfo.ChassisId | export-excel $filename -worksheetname $worksheetname -startcolumn 1 -startrow 3
echo $bladeinfo.SlotId | export-excel $filename -worksheetname $worksheetname -startcolumn 2 -startrow 3
echo $bladeinfo.AssignedToDn | export-excel $filename -worksheetname $worksheetname -startcolumn 3 -startrow 3
echo $bladeinfo.UsrLbl | export-excel $filename -worksheetname $worksheetname -startcolumn 4 -startrow 3
echo $bladeinfo.Model | export-excel $filename -worksheetname $worksheetname -startcolumn 5 -startrow 3
echo $bladeinfo.Vid | export-excel $filename -worksheetname $worksheetname -startcolumn 6 -startrow 3
echo $bladeinfo.Serial | export-excel $filename -worksheetname $worksheetname -startcolumn 7 -startrow 3
echo $bladeinfo.Association | export-excel $filename -worksheetname $worksheetname -startcolumn 8 -startrow 3
echo $bladeinfo.TotalMemory | export-excel $filename -worksheetname $worksheetname -startcolumn 9 -startrow 3
echo $bladeinfo.NumOfCpus | export-excel $filename -worksheetname $worksheetname -startcolumn 10 -startrow 3
echo $bladeinfo.NumOfCores | export-excel $filename -worksheetname $worksheetname -startcolumn 11 -startrow 3
echo $bladeinfo.Ucs | export-excel $filename -worksheetname $worksheetname -startcolumn 12 -startrow 3


Disconnect-Ucs